bl_info = {
    "name" : "Fire Scatter",
    "author" : "CGBlender", 
    "description" : "Fire Scatter addon for Blender allows you to scatter a fire on a surface.",
    "blender" : (3, 6, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "waring" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews

import os


def string_to_int(value):
    if value.isdigit():
        return int(value)
    return 0

def string_to_icon(value):
    if value in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items.keys():
        return bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items[value].value
    return string_to_int(value)
    
def icon_to_string(value):
    for icon in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items:
        if icon.value == value:
            return icon.name
    return "NONE"
    
def enum_set_to_string(value):
    if type(value) == set:
        if len(value) > 0:
            return "[" + (", ").join(list(value)) + "]"
        return "[]"
    return value
    
def string_to_type(value, to_type, default):
    try:
        value = to_type(value)
    except:
        value = default
    return value

addon_keymaps = {}
_icons = None
fire_scatter = {}



class SNA_OT_Scat2_E361F(bpy.types.Operator):
    bl_idname = "sna.scat2_e361f"
    bl_label = "scat2"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    
    
    @classmethod
    def poll(cls, context):
        return not False
    def execute(self, context):
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'fire itest scater.blend') + r'\NodeTree', filename='Fire S2', link=False)
        bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='NODES')
        bpy.context.active_object.modifiers.active.node_group = bpy.data.node_groups['Fire S2']
        return {"FINISHED"}
    
    def invoke(self, context, event):
        
        
        return self.execute(context)
class SNA_OT_Scat3_1B0D3(bpy.types.Operator):
    bl_idname = "sna.scat3_1b0d3"
    bl_label = "scat3"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    
    
    @classmethod
    def poll(cls, context):
        return not False
    def execute(self, context):
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'fire itest scater.blend') + r'\NodeTree', filename='Fire S3', link=False)
        bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='NODES')
        bpy.context.active_object.modifiers.active.node_group = bpy.data.node_groups['Fire S3']
        return {"FINISHED"}
    
    def invoke(self, context, event):
        
        
        return self.execute(context)
class SNA_OT_Scat_3E6D5(bpy.types.Operator):
    bl_idname = "sna.scat_3e6d5"
    bl_label = "scat"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    
    
    @classmethod
    def poll(cls, context):
        return not False
    def execute(self, context):
        bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'fire itest scater.blend') + r'\NodeTree', filename='Fire S1', link=False)
        bpy.ops.object.modifier_add('INVOKE_DEFAULT', type='NODES')
        bpy.context.active_object.modifiers.active.node_group = bpy.data.node_groups['Fire S1']
        return {"FINISHED"}
    
    def invoke(self, context, event):
        
        
        return self.execute(context)
class SNA_PT_FIRE_SCATTER_74311(bpy.types.Panel):
    bl_label = 'Fire Scatter'
    bl_idname = 'SNA_PT_FIRE_SCATTER_74311'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'FS'
    bl_order = 0
    
    
    @classmethod
    def poll(cls, context):
        return not (False)
    
    def draw_header(self, context):
        layout = self.layout
        
    def draw(self, context):
        layout = self.layout
        op = layout.operator('sna.scat_3e6d5', text='Scatter Fire F1', icon_value=0, emboss=True, depress=False)
        op = layout.operator('sna.scat2_e361f', text='Scatter Fire F2', icon_value=0, emboss=True, depress=False)
        op = layout.operator('sna.scat3_1b0d3', text='Scatter Fire F3', icon_value=0, emboss=True, depress=False)
        col_7D9FD = layout.column(heading='', align=False)
        col_7D9FD.alert = False
        col_7D9FD.enabled = True
        col_7D9FD.use_property_split = False
        col_7D9FD.use_property_decorate = False
        col_7D9FD.scale_x = 1.0
        col_7D9FD.scale_y = 1.0
        col_7D9FD.alignment = 'Expand'.upper()
        col_7D9FD.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_5"]', text='Random Seed', icon_value=0, emboss=True)
        col_7D9FD.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_6"]', text='Noise Seed', icon_value=0, emboss=True)
        col_7D9FD.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_2"]', text='F Scale', icon_value=0, emboss=True)
        col_7D9FD.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_3"]', text='Density', icon_value=0, emboss=True)
        col_7D9FD.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_13"]', text='F Density Factor', icon_value=0, emboss=True)
        col_9332E = layout.column(heading='', align=False)
        col_9332E.alert = False
        col_9332E.enabled = True
        col_9332E.use_property_split = False
        col_9332E.use_property_decorate = False
        col_9332E.scale_x = 1.0
        col_9332E.scale_y = 1.0
        col_9332E.alignment = 'Expand'.upper()
        col_9332E.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Random Value'].inputs[2], 'default_value', text='Scale Min', icon_value=0, emboss=True)
        col_9332E.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Random Value'].inputs[3], 'default_value', text='Scale Max', icon_value=0, emboss=True)
        col_9332E.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Random Value'].inputs[8], 'default_value', text='Scale Random', icon_value=0, emboss=True)
        col_9332E.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Distribute Points on Faces'].inputs[4], 'default_value', text='Density', icon_value=0, emboss=True)
        col_9332E.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Distribute Points on Faces'].inputs[6], 'default_value', text='Seed', icon_value=0, emboss=True)
        col_9332E.prop(bpy.context.active_object.modifiers.active.node_group.nodes['Align Euler to Vector'].inputs[1], 'default_value', text='Rotation', icon_value=0, emboss=True)
        



def register():
    
    global _icons
    _icons = bpy.utils.previews.new()
    
    
    bpy.utils.register_class(SNA_OT_Scat2_E361F)
    bpy.utils.register_class(SNA_OT_Scat3_1B0D3)
    bpy.utils.register_class(SNA_OT_Scat_3E6D5)
    bpy.utils.register_class(SNA_PT_FIRE_SCATTER_74311)

def unregister():
    
    global _icons
    bpy.utils.previews.remove(_icons)
    
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    
    
    bpy.utils.unregister_class(SNA_OT_Scat2_E361F)
    bpy.utils.unregister_class(SNA_OT_Scat3_1B0D3)
    bpy.utils.unregister_class(SNA_OT_Scat_3E6D5)
    bpy.utils.unregister_class(SNA_PT_FIRE_SCATTER_74311)

